(*  GREATIS WINDOW FINDER                                    *)
(*  Copyright (C) 2005-2014 Greatis Software                 *)
(*                                                           *)
(*  http://www.greatis.com/delphicb/windowfinder/            *)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WindowFinder, Second, StdCtrls, ExtCtrls, ShellAPI;

type
  TfrmMain = class(TForm)
    WF: TWindowFinder;
    ModeRadioGroup: TRadioGroup;
    ActionsGroupBox: TGroupBox;
    FlashCheckBox: TCheckBox;
    BringToTopCheckBox: TCheckBox;
    SendToBackCheckBox: TCheckBox;
    MakeTopmostCheckBox: TCheckBox;
    MakeNoTopmostCheckBox: TCheckBox;
    MaximizeCheckBox: TCheckBox;
    MinimizeCheckBox: TCheckBox;
    RestoreCheckBox: TCheckBox;
    ShowCheckBox: TCheckBox;
    HideCheckBox: TCheckBox;
    CloseCheckBox: TCheckBox;
    FindButton: TButton;
    MoreButton: TButton;
    CloseButton: TButton;
    ClassLabel: TLabel;
    ClassEdit: TEdit;
    TitleLabel: TLabel;
    TitleEdit: TEdit;
    HandleLabel: TLabel;
    HandleEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure MoreButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure FindButtonClick(Sender: TObject);
    procedure HandleEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
var
  LF: TLogFont;
begin
  SystemParametersInfo(SPI_GETICONTITLELOGFONT,SizeOf(LF),@LF,0);
  with LF,Font do
  begin
    ScaleBy(Abs(lfHeight),Abs(Height));
    Handle:=CreateFontIndirect(LF);
  end;
end;

procedure TfrmMain.MoreButtonClick(Sender: TObject);
begin
  ShellExecute(Handle,'open','http://www.greatis.com/delphicb/windowfinder/',nil,nil,SW_SHOWDEFAULT);
end;

procedure TfrmMain.CloseButtonClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmMain.FindButtonClick(Sender: TObject);
var
  i: Integer;
begin
  with WF do
  begin
    WindowClass:=ClassEdit.Text;
    WindowTitle:=TitleEdit.Text;
    if HandleEdit.Text<>'' then WindowHandle:=StrToInt(HandleEdit.Text)
    else WindowHandle:=0;
    Mode:=TFindMode(ModeRadioGroup.ItemIndex);
    Actions:=[];
    with ActionsGroupBox do
      for i:=0 to Pred(ControlCount) do
        with Controls[i] as TCheckBox do
          if Checked then Actions:=Actions+[TFindAction(TabOrder)];
    with HandleEdit do
      if Find then Text:=IntToStr(LastFound)
      else Text:='0';
  end;
end;

procedure TfrmMain.HandleEditKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9',Char(VK_BACK)]) then Key:=#0;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  SecondForm.Show;
end;

end.
